<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Bootstrap Grid System</title>
    <!-- Start Bootstrap CSS Link -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">
    <!-- End Bootstrap CSS Link -->
    <!-- Start Google Fonts -->
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link href="https://fonts.googleapis.com/css2?family=Montserrat&display=swap" rel="stylesheet">
    <!-- End Google Fonts -->
    <!-- Start Owned CSS -->
    <link rel="stylesheet" href="index.css">
    <!-- End Owned CSS -->
</head>

<body>
    <!-- 
        BS's responsive grid system primarily focus on the pattern of:
        C-R-C (stands for Container, Row, Col)
            container - sets the max width of the layout
            row - holds the col and prevents overflow
            col - holds the actual content and its width is determine by the number of col in a row. By default, there should be 12 col in 1 row
     -->
    <div class="container bg-secondary">
        <h2>Container</h2>
        <div class="row">
            <div class="col-6 bg-primary border border-dark">
                Div uses 6 columns out of 12
            </div>
            <div class="col-6 bg-danger border border-dark">
                Div uses 6 columns out of 12
            </div>
        </div>
    </div>
    <div class="container-fluid bg-dark text-white mt-5">
        <h2>Container Fluid</h2>
        <!-- 
            Row holds column. If column are added without being inside a row, they will not be displayed in a row AND therefore will not completely use or take advantage of our grid system.

            Rows can only hold 12 columns, if the divs inside exceed 12 column, the last div will be overflowed to the next row.

            Essentially, what we're doing is setting up a layout wherein we can determine the sizes of each part of our page based on the number of columns.
         -->
        <div class="row">
            <div class="col-4 bg-info border border dark">
                Div used 4 columns out of 12
            </div>
            <div class="col-4 bg-warning border border dark">
                Div used 4 columns out of 12
            </div>
            <div class="col-4 bg-secondary border border dark">
                Div used 4 columns out of 12
            </div>
            <div class="col-1 bg-success border border dark">
                Div used 4 columns out of 12
            </div>
        </div>
    </div>
    <div class="container-fluid">
        <h1>Page Layout</h1>
        <div class="row">
            <div class="col-12 col-md-8 text-center order-2 order-md-1">
                <h2>What is HTML?</h2>
                <p>
                    Lorem, ipsum dolor, sit amet consectetur adipisicing elit. Natus doloribus accusantium quasi quibusdam est, laboriosam itaque hic, numquam aperiam tempore, dolorum explicabo, a facere sint omnis. Dignissimos, repellat vitae deserunt.
                    Sapiente laudantium hic, corporis, doloribus ducimus odio ipsa nam dolore veritatis maxime qui quaerat. Labore dolor commodi aperiam autem minima, alias, sit odit magnam facilis, molestias et mollitia deleniti, rerum.
                </p>
            </div>
            <div class="col-12 col-md-4 text-center order-1 order-md-2">
                <img class="img-fluid img-thumbnail shadow" src="images/img_1.jpg" alt="sample_img">
            </div>
        </div>
    </div>
    <!-- Breakpoints
        When designing the number of columns a div can occupy the effect, by default, will be from the smallest to largest meaning:
            col-12 - 12 columns from the smallest screen to largest
            col-8 - 8 columns from smallest to the largest

            However, not all layouts would or should look the same across all screens. We have to consider the readability and the sizes of each columns in smaller screen.

        Breakpoints
            - are points/screens where in we can set a different layout or number of columns to a div

            ex.
                <div class="col-12 col-md-4">
                    this div is a 12 column from the smallers, to the small screen. 4 columns from the medium screen to the largest
                </div>
            Columns can be sized with breakpoints starting from the smallest screen:
                col-* - from the smallest screen
                col-sm-* breakpoint from small screen about 576px screen width
                col-md-* breakpoint from medium screen or about 768px screen width
                col-lg-* breakpoint from large screen or about 992 screen width
                col-xl-* break point from largest screen or about 1200 screen width

                <div class="col-12 col-md-3">
                    How many columns in the smallest screen?12
                    How many columns in the medium screen? 3
                    How many columns in the large to xl screen? 3
                <div class="col-6 col-md-12">
                    How many columns in the smallest screen?6
                    How many columns in the medium screen? 12
                    How many columns in the large to xl screen? 12
      -->
    <!-- Mini Activity 1 -->
    <div class="container-fluid">
        <div class="row my-5">
            <div class="col-2 bg-success border border-dark">Text-1</div>
            <div class="col-3 bg-primary border border-dark">Text-2</div>
            <div class="col-5 bg-danger border border-dark offset-2">Text-3</div>
        </div>
    </div>
    <!-- End Mini Activity 1 -->
    <!-- Solution Mini-activity -->
    <div class="row my-5">
        <div class="col-2 bg-success border border-dark">
            text-1
        </div>
        <div class="col-3 bg-primary border border-dark">
            text-2
        </div>
        <div class="col-5 offset-2 bg-danger border border-dark">
            text-3
        </div>
    </div>
    <div class="row my-5">
        <div class="col-3 mx-auto">
            <!-- You can actually use mx-auto to center your column -->
            <img class="img-fluid" src="https://i.pinimg.com/474x/ec/32/45/ec324549310ed4c5966ffe05f718e66c.jpg" alt="...">
        </div>
    </div>
    <div class="row">
        <div class="col-3 mx-auto text-center">
            <h1>Yusuke Urameshi</h1>
            <h3>Spirit Detective</h3>
        </div>
    </div>
    <!-- Order -->
    <!-- You can actually change the order of divs in a row. You can change the order of divs in a row per screen or breakpoint -->
    <div class="row my-5">
        <div class="col-12 col-md-4 bg-warning border border-dark p-3 order-3 order-md-3">
            Lebron James
        </div>
        <div class="col-12 col-md-4 text-white bg-dark border border-dark p-3 order-1 order-md-2">
            Kevin Durant
        </div>
        <div class="col-12 col-md-4 bg-primary border border-dark p-3 order-2 order-md-1">
            Stephen Curry
        </div>
    </div>
    <!-- Mini Activity 2 -->
    <div class="container-fluid">
        <div class="row">
            <div class="col-sm-12 col-lg-4 order-md-3">Charmander</div>
            <div class="col-sm-12 col-lg-4 order-md-1"> Squirtle</div>
            <div class="col-sm-12 col-lg-4 order-md-2">Bulbasaur</div>
        </div>
    </div>
    <!-- Start Bootstrap JS Dependencies -->
    <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>
    <!-- End Bootstrap JS Dependencies -->
</body>

</html>